import Pengyne
import random

engine = Pengyne.GetEngine()

GOOMBACOUNT = 1000

gl = Pengyne.GL()

class SpritesState(Pengyne.GameState):
	def __init__(self):
		Pengyne.GameState.__init__(self)
		
		# change the camera to 2d
		engine.GetCamera().SetupView2D()
		
		# create the shader
		self.shader = Pengyne.Shader()
		# both vertex and fragment shaders are needed
		self.shader.VertexFromFile("Sprite.vert")
		self.shader.FragmentFromFile("Sprite.frag")
		# dont forget to link
		self.shader.Link()
		
		self.tiles = engine.GetResource("loztiles.tsx")
		# get the sprite texture
		self.goomba = engine.Resources().Load("goomba-fly.png")
		#self.goomba = self.tiles.GetTileByID(0)
		self.goombasprites = Pengyne.SpriteLayer()
		self.goombasprites.SetShader(self.shader)
		
		self.goombasprites2 = Pengyne.SpriteLayer()
		self.goombasprites2.SetShader(self.shader)
		
		self.screensize = ( engine.GetScreenWidth(), engine.GetScreenHeight())
		self.goombasize = (self.goomba.GetWidth(), self.goomba.GetHeight())
		self.goombalist = []
		
		for i in range(GOOMBACOUNT):
			x = random.randint(0, self.screensize[0] - self.goombasize[0])
			y = random.randint(0, self.screensize[1] - self.goombasize[1])
			dir = self.RandomDirection()
			#self.goombasprites.Add(self.goomba, x, y)
			self.goombalist.append([self.goombasprites.Add(self.goomba, x, y), dir])
		x = random.randint(0, self.screensize[0] - self.goombasize[0])
		y = random.randint(0, self.screensize[1] - self.goombasize[1])
		dir = self.RandomDirection()
		self.texture2 = self.tiles.GetTile(0,21)
		self.independent = self.goombasprites2.Add(self.texture2, x, y)
		self.goombalist.append([self.independent, dir])
		self.renderback = True
		self.update = True
		self.map = False
		self.updateposition = True
		self.depth = True
		
		engine.SetActionKey("T", "ToggleRender")
		engine.SetActionKey("C", "ToggleUpdate")
		engine.SetActionKey("M", "ToggleMap")
		engine.SetActionKey("U", "ToggleUpdatePosition")
		engine.SetActionKey("D", "ToggleDepth")
	# generate a random direction for the goombas to move
	def RandomDirection(self):
		return [random.uniform(-1.0, 1.0), random.uniform(-1.0, 1.0)]
		
	def Render(self):
		updatelist = self.goombalist
		if not self.update:
			updatelist = self.goombalist[-1:]
		rand = self.RandomDirection
		width, height = self.screensize
		width -= self.goombasize[0]
		height -= self.goombasize[1]
		if not self.depth:
			for entry in [Pengyne.GL.DEPTH_TEST, Pengyne.GL.BLEND]:
					Pengyne.GL.Disable(entry)
		def update(goomba):
		# update the position of the goombas, and generate a new direction if they reach an edge
			dx, dy = goomba[1]
			gsprite = goomba[0]
			if self.updateposition or gsprite == self.independent:
				gsprite.Move(dx, dy)
			px = gsprite.GetPositionX()
			py = gsprite.GetPositionY()
			if px < 0 or px >= width or py < 0 or py >= height:
				 goomba[1] = (-dx, -dy)
				 
		if self.map:
			map(update, updatelist)
		else:
			for goomba in updatelist:
				update(goomba)
		# draw the goombas
		if self.renderback:
			engine.Render(self.goombasprites)
		engine.Render(self.goombasprites2)
	
	def OnClose(self):
		engine.Quit()
		
	def OnClick(self, event):
		pass

	def OnKeyDown(self, action):
		if action == "Quit":
			engine.Quit()
		elif action == "ToggleRender":
			self.renderback = not self.renderback
		elif action == "ToggleUpdate":
			self.update = not self.update
		elif action == "ToggleMap":
			self.map = not self.map
		elif action == "ToggleUpdatePosition":
			self.updateposition = not self.updateposition
		elif action == "ToggleDepth":
			self.depth = not self.depth
			
	def OnKeyUp(self, action):
		pass
