import Pengyne

engine = Pengyne.GetEngine()

class MapViewer(Pengyne.GameState):
	def __init__(self):
		Pengyne.GameState.__init__(self)
		
		# change the camera to 2d
		engine.GetCamera().SetupView2D()
		
		# create the shader
		self.shader = Pengyne.Shader()
		# both vertex and fragment shaders are needed
		self.shader.VertexFromFile("Sprite.vert")
		self.shader.FragmentFromFile("Sprite.frag")
		# dont forget to link
		self.shader.Link()
		
		# Load the map and set its shader
		# the map MUST be set to Base64 (uncompressed) for now
		# in Edit -> Prefrences
		self.map = engine.GetResource("loz.tmx")
		self.map.SetShader(self.shader)
		
	
		
	def Render(self):
		# You can move the map or move the camera		
		self.map.Move((-1,0, 0))
		engine.GetCamera().Move((0,-1, 0))
		engine.Render(self.map)
	
	def OnClose(self):
		engine.Quit()
		
	def OnClick(self, event):
		pass

	def OnKeyDown(self, action):
		if action == "Quit":
			engine.Quit()
			
	def OnKeyUp(self, action):
		pass
