uniform mat4 mvp_matrix;
uniform mat4 model_matrix;
uniform mat4 view_matrix;

attribute vec3 Position;
attribute vec3 Normal;
attribute vec4 Color;


varying vec4 pass_color;
varying vec3 normal;
varying vec3 globalpos;

void main()
{
	gl_Position = mvp_matrix * vec4(Position, 1.0) ;
	globalpos = (model_matrix * view_matrix * vec4(Position, 0.0)).xyz;
	normal = normalize(model_matrix * view_matrix * vec4(Normal, 0.0)).xyz;
	
	pass_color = Color;
}
